=== debian/changelog ===
roct-thunk-interface (3.7.0+dfsg-1) unstable; urgency=medium

  [ Norbert Preining ]
  * Drop unused B-D libpci-dev.
  * Add myself to uploaders.

  [ Mo Zhou ]
  * New upstream version 3.7.0+dfsg
  * Update the regex in watch file to reflect upstream changes.
  * Change the maintainer mail address into debian-ai@l.d.o
  * Update installation paths according to upstream changes.
  * Refresh symbols control file.
  * Remove unnecessary ${shlibs:Depends} from d/control.

 -- Mo Zhou <lumin@debian.org>  Thu, 17 Sep 2020 16:46:39 +0800

roct-thunk-interface (3.0.0+dfsg-1~exp1) experimental; urgency=medium

  * Initial release. (Closes: #943556)

 -- Mo Zhou <lumin@debian.org>  Wed, 25 Mar 2020 15:01:59 +0800
