=== debian/control ===
Source: roct-thunk-interface
Section: video
Homepage: https://github.com/RadeonOpenCompute/ROCT-Thunk-Interface
Priority: optional
Standards-Version: 4.4.1
Vcs-Git: https://salsa.debian.org/rocm-team/roct-thunk-interface.git
Vcs-Browser: https://salsa.debian.org/rocm-team/roct-thunk-interface
Maintainer: ROCm Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>, Norbert Preining <norbert@preining.info>
Build-Depends: cmake,
               debhelper-compat (= 12),
               libnuma-dev,
               libudev-dev,
               pkg-config,
               zlib1g-dev

Package: libhsakmt1
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Thunk library for AMD KFD (shlib)
 This package includes the user-mode API interfaces used to interact with the
 ROCk driver. Currently supported agents include only the AMD/ATI Fiji family
 of discrete GPUs.
 .
 This package contains the shared object.

Package: libhsakmt-dev
Section: libdevel
Architecture: any
Depends: libhsakmt1 (= ${binary:Version}), ${misc:Depends},
Description: Thunk library for AMD KFD (dev)
 This package includes the user-mode API interfaces used to interact with the
 ROCk driver. Currently supported agents include only the AMD/ATI Fiji family
 of discrete GPUs.
 .
 This package contains the development files.
