=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure
	sed -i -e 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' \
		debian/libhsakmt-dev.install
