=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%roct-thunk-interface-$1.tar.gz%, repacksuffix=+dfsg, dversionmangle=s/\+dfsg\d*$//" \
https://github.com/RadeonOpenCompute/ROCT-Thunk-Interface/tags \
(?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian uupdate
