## roct-thunk-interface 5.0.0+dfsg

=== debian/changelog ===
roct-thunk-interface (5.0.0+dfsg-1) unstable; urgency=medium

  [ Maxime Chambonnet ]
  * New upstream version 5.0.0+dfsg

  [ Mo Zhou ]
  * Update copyright.

 -- Mo Zhou <lumin@debian.org>  Sat, 12 Feb 2022 13:23:02 -0500

roct-thunk-interface (4.5.2+dfsg-1) unstable; urgency=medium

  [ Maxime Chambonnet ]
  * New upstream version 4.5.2+dfsg
  * Updated symbol file, added "Build-Depends-Package"
  * Added libdrm-dev as build dependency
  * Passed dpkg-buildflags hardening
  * Spelling patch
  * Added myself to uploaders

  [ Mo Zhou ]
  * Create libhsakmt-dev.install.in as a template for sed editing.

 -- Mo Zhou <lumin@debian.org>  Fri, 14 Jan 2022 22:26:54 -0500
