=== debian/control ===
--- 
+++ 
@@ -1,18 +1,22 @@
 Source: roct-thunk-interface
-Section: video
+Section: devel
 Homepage: https://github.com/RadeonOpenCompute/ROCT-Thunk-Interface
 Priority: optional
-Standards-Version: 4.4.1
+Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/rocm-team/roct-thunk-interface.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/roct-thunk-interface
 Maintainer: ROCm Team <debian-ai@lists.debian.org>
-Uploaders: Mo Zhou <lumin@debian.org>, Norbert Preining <norbert@preining.info>
+Uploaders: Mo Zhou <lumin@debian.org>,
+           Norbert Preining <norbert@preining.info>,
+           Maxime Chambonnet <maxzor@maxzor.eu>,
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
+               libdrm-dev,
                libnuma-dev,
                libudev-dev,
                pkg-config,
-               zlib1g-dev
+               zlib1g-dev,
+Rules-Requires-Root: no
 
 Package: libhsakmt1
 Section: libs
