## roct-thunk-interface 5.2.0+dfsg

=== debian/changelog ===
roct-thunk-interface (5.2.0+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Set upstream metadata fields.
  * Apply multi-arch hints.
    + libhsakmt1: Add Multi-Arch: same.
  * d/control: add myself to uploaders.
  * d/copyright: remove superfluous file patterns.
  * d/copyright: refresh copyright information.

 -- Étienne Mollier <emollier@debian.org>  Sun, 03 Jul 2022 12:28:43 +0200

roct-thunk-interface (5.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 5.1.0+dfsg

 -- Mo Zhou <lumin@debian.org>  Thu, 07 Apr 2022 12:10:57 -0400
