=== debian/control ===
--- 
+++ 
@@ -2,13 +2,14 @@
 Section: devel
 Homepage: https://github.com/RadeonOpenCompute/ROCT-Thunk-Interface
 Priority: optional
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Git: https://salsa.debian.org/rocm-team/roct-thunk-interface.git
 Vcs-Browser: https://salsa.debian.org/rocm-team/roct-thunk-interface
 Maintainer: ROCm Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>,
            Norbert Preining <norbert@preining.info>,
            Maxime Chambonnet <maxzor@maxzor.eu>,
+           Étienne Mollier <emollier@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
                libdrm-dev,
@@ -22,6 +23,7 @@
 Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
 Description: Thunk library for AMD KFD (shlib)
  This package includes the user-mode API interfaces used to interact with the
  ROCk driver. Currently supported agents include only the AMD/ATI Fiji family
