## roct-thunk-interface 5.2.3+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,19 +23,7 @@
 ##
 ################################################################################
 
-cmake_minimum_required ( VERSION 3.5.0 )
-
-## Cosmetic Cmake version warnings.
-if(NOT EXISTS VERSION_WARNED)
-  set (VERSION_WARNED FALSE CACHE BOOL "")
-endif()
-if(${CMAKE_VERSION} VERSION_LESS "3.6.0" AND NOT ${VERSION_WARNED})
-  message("Your CMake version is too old for full functionality.
-Generated package file names may be incorrect.
-Please update to CMake 3.6 or newer to generate correct package file names")
-  set( VERSION_WARNED TRUE CACHE BOOL "Suppress cosmetic build errors due to CMake version after first warning." FORCE )
-  mark_as_advanced( FORCE VERSION_WARNED )
-endif()
+cmake_minimum_required ( VERSION 3.6.3 )
 
 set ( HSAKMT "hsakmt" )
 set ( HSAKMT_PACKAGE "hsakmt-roct" )
@@ -44,8 +32,9 @@
 
 project ( ${HSAKMT_TARGET} VERSION 1.9.0)
 
+# Build thunk as static by default
 if ( NOT DEFINED BUILD_SHARED_LIBS )
-  set ( BUILD_SHARED_LIBS "on" )
+  set ( BUILD_SHARED_LIBS "off" )
 endif()
 set ( BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS} CACHE BOOL "Build shared library (.so) or not.")
 
@@ -106,7 +95,24 @@
 
 ## Linker Flags
 ## Add --enable-new-dtags to generate DT_RUNPATH
-set (HSAKMT_LINK_FLAGS "-Wl,--enable-new-dtags -Wl,--version-script=${HSAKMT_LINKER_SCRIPT} -Wl,-soname=${HSAKMT_COMPONENT}.so.${LIB_VERSION_MAJOR} -Wl,-z,nodelete -Wl,-no-undefined" )
+set (HSAKMT_LINK_FLAGS "${HSAKMT_LINK_FLAGS} -Wl,--enable-new-dtags -Wl,--version-script=${HSAKMT_LINKER_SCRIPT} -Wl,-soname=${HSAKMT_COMPONENT}.so.${LIB_VERSION_MAJOR} -Wl,-z,nodelete")
+
+## Address Sanitize Flag
+if ( ${ADDRESS_SANITIZER} )
+    set ( HSAKMT_C_FLAGS "${HSAKMT_C_FLAGS}" -fsanitize=address )
+    set ( HSAKMT_LINK_FLAGS "${HSAKMT_LINK_FLAGS} -fsanitize=address" )
+    if ( BUILD_SHARED_LIBS )
+        set ( HSAKMT_LINK_FLAGS "${HSAKMT_LINK_FLAGS} -shared-libsan" )
+    else ()
+        set ( HSAKMT_LINK_FLAGS "${HSAKMT_LINK_FLAGS} -static-libsan" )
+    endif ()
+else ()
+    if ( CMAKE_COMPILER_IS_GNUCC )
+        set ( HSAKMT_LINK_FLAGS "${HSAKMT_LINK_FLAGS} -Wl,-no-undefined" )
+    else ()
+        set ( HSAKMT_LINK_FLAGS "${HSAKMT_LINK_FLAGS} -Wl,-undefined,error" )
+    endif ()
+endif ()
 
 ## Source files
 set ( HSAKMT_SRC "src/debug.c"
@@ -116,14 +122,15 @@
                  "src/libhsakmt.c"
                  "src/memory.c"
                  "src/openclose.c"
-                 "src/pci_ids.c"
                  "src/perfctr.c"
                  "src/pmc_table.c"
                  "src/queues.c"
                  "src/time.c"
                  "src/topology.c"
                  "src/rbtree.c"
-                 "src/version.c")
+                 "src/spm.c"
+                 "src/version.c"
+                 "src/svm.c")
 
 ## Declare the library target name
 add_library ( ${HSAKMT_TARGET} "")
@@ -140,17 +147,56 @@
   PRIVATE
   ${CMAKE_CURRENT_SOURCE_DIR}/src )
 
-target_compile_options(${HSAKMT_TARGET} PRIVATE ${HSAKMT_C_FLAGS})
 set_property(TARGET ${HSAKMT_TARGET} PROPERTY LINK_FLAGS ${HSAKMT_LINK_FLAGS})
 
 ## Set the VERSION and SOVERSION values
 set_property ( TARGET ${HSAKMT_TARGET} PROPERTY VERSION "${LIB_VERSION_STRING}" )
 set_property ( TARGET ${HSAKMT_TARGET} PROPERTY SOVERSION "${LIB_VERSION_MAJOR}" )
 
-#find_package(PkgConfig)
+find_package(PkgConfig)
+# get OS-info for OS-specific build dependencies
+get_os_info()
+
+find_package(PkgConfig)
+# Check for libraries required for building
+find_library(LIBC NAMES libc.so.6 REQUIRED)
+find_library(NUMA NAMES libnuma.so REQUIRED)
+message(STATUS "LIBC:" ${LIBC})
+message(STATUS "NUMA:" ${NUMA})
+
+## If environment variable DRM_DIR is set, the script
+## will pick up the corresponding libraries from that path.
+if( DEFINED ENV{DRM_DIR} )
+#assume header files and libraries are under the same path
+    set ( DRM_DIR $ENV{DRM_DIR} )
+    set ( DRM_INCLUDE_DIRS ${DRM_DIR}/include )
+    link_directories(${DRM_DIR}/lib64)
+    set ( DRM_LIBRARIES drm )
+    set ( DRM_AMDGPU_LIBRARIES drm_amdgpu )
+else()
+# The module name passed to pkg_check_modules() is determined by the
+# name of file *.pc
+    pkg_check_modules(DRM REQUIRED libdrm)
+    pkg_check_modules(DRM_AMDGPU REQUIRED libdrm_amdgpu)
+    include_directories(${DRM_AMDGPU_INCLUDE_DIRS})
+endif()
+include_directories(${DRM_INCLUDE_DIRS})
+
 target_link_libraries ( ${HSAKMT_TARGET}
-  PRIVATE pthread rt numa
+  PRIVATE ${DRM_LDFLAGS} ${DRM_AMDGPU_LDFLAGS} pthread rt ${LIBC} ${NUMA}
 )
+
+target_compile_options(${HSAKMT_TARGET} PRIVATE ${DRM_CFLAGS} ${HSAKMT_C_FLAGS})
+if(NOT DISTRO_ID MATCHES "ubuntu")
+  find_library(LIBGCC NAMES libgcc_s.so.1 REQUIRED)
+  message(STATUS "LIBGCC:" ${LIBGCC})
+  target_link_libraries( ${HSAKMT_TARGET} PRIVATE ${LIBGCC} )
+else()
+  find_library(UDEV NAMES libudev.so libudev.a REQUIRED)
+  message(STATUS "UDEV:" ${UDEV})
+  find_package(ZLIB REQUIRED)
+  target_link_libraries( ${HSAKMT_TARGET} PRIVATE ${ZLIB} ${UDEV} )
+endif()
 
 ## Define default paths and packages.
 if( CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT )
@@ -162,10 +208,10 @@
 
 # Installs binaries and exports the library usage data to ${HSAKMT_TARGET}Targets
 install ( TARGETS ${HSAKMT_TARGET} EXPORT ${HSAKMT_TARGET}Targets
-  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT binary
-  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT binary )
-
-install ( FILES ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.md DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT binary )
+  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT devel
+  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT devel )
+
+#install ( FILES ${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.md DESTINATION ${CMAKE_INSTALL_DOCDIR} COMPONENT devel )
 
 # Install public headers
 install ( DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
@@ -226,45 +272,17 @@
 
 install ( FILES ${CMAKE_CURRENT_BINARY_DIR}/libhsakmt.pc DESTINATION ${CMAKE_INSTALL_DATADIR}/pkgconfig COMPONENT devel)
 
+###########################
+# Packaging directives
+###########################
 # Use component packaging
-set ( CPACK_COMPONENTS_GROUPING IGNORE )
-set ( CPACK_COMPONENTS_ALL binary devel )
-set ( CPACK_DEB_COMPONENT_INSTALL ON )
-set ( CPACK_RPM_COMPONENT_INSTALL ON )
-
-## Add the packaging directives for the runtime library.
-set ( CPACK_PACKAGE_VENDOR "Advanced Micro Devices, Inc." )
-set ( CPACK_PACKAGE_VERSION_MAJOR ${BUILD_VERSION_MAJOR} )
-set ( CPACK_PACKAGE_VERSION_MINOR ${BUILD_VERSION_MINOR} )
-set ( CPACK_PACKAGE_VERSION_PATCH ${BUILD_VERSION_PATCH} )
-set ( CPACK_PACKAGE_CONTACT "Advanced Micro Devices, Inc." )
-set ( CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.md" )
-
-## Component packaging, BINARY
-set ( CPACK_COMPONENT_BINARY_DESCRIPTION "HSAKMT library for AMD KFD support" )
-set ( CPACK_DEBIAN_BINARY_PACKAGE_NAME ${HSAKMT_PACKAGE} )
-set ( CPACK_DEBIAN_BINARY_FILE_NAME "${CPACK_DEBIAN_BINARY_PACKAGE_NAME}_${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}_amd64.deb" )
-set ( CPACK_RPM_BINARY_PACKAGE_NAME ${HSAKMT_PACKAGE} )
-set ( CPACK_RPM_BINARY_FILE_NAME "${CPACK_RPM_BINARY_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}.x86_64.rpm" )
-
-#checking for OS-version
-if( EXISTS "/etc/os-release" )
-    file( STRINGS "/etc/os-release" DISTRO_ID REGEX "^ID=" )
-    file( STRINGS "/etc/os-release" DISTRO_RELEASE REGEX "^VERSION_ID=" )
-    string( REPLACE "ID=" "" DISTRO_ID "${DISTRO_ID}" )
-    string( REPLACE "VERSION_ID=" "" DISTRO_RELEASE "${DISTRO_RELEASE}" )
-    message( STATUS "Detected distribution: ${DISTRO_ID}:${DISTRO_RELEASE}" )
-elseif( EXISTS "/etc/centos-release" )
-    # Example: CentOS release 6.10 (Final)
-    file( STRINGS "/etc/centos-release" DISTRO_FULL_STR REGEX "release" )
-    string( REGEX MATCH "^[a-zA-Z]+" DISTRO_ID "${DISTRO_FULL_STR}" )
-    string( TOLOWER "${DISTRO_ID}" DISTRO_ID )
-    string( REGEX MATCH "[0-9]+" DISTRO_RELEASE "${DISTRO_FULL_STR}" )
-    message( STATUS "Detected distribution: ${DISTRO_ID}:${DISTRO_RELEASE}" )
-else()
-     message( STATUS "Not able to detect OS" )
-endif()
-
-# Debian package specific variables
-set ( CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/RadeonOpenCompute/ROCT-Thunk-Interface" )
-set ( CPACK_DEBIAN_BINARY_PACKAGE_CONTROL_EXTRA "${CMAKE_CURRENT_SOURCE_DIR}/DEBIAN/postinst;${CMAKE_CURRENT_SOURCE_DIR}/DEBIAN/prerm" )
+set(CPACK_COMPONENTS_GROUPING IGNORE)
+set(CPACK_DEB_COMPONENT_INSTALL ON)
+set(CPACK_RPM_COMPONENT_INSTALL ON)
+set(CPACK_PACKAGE_VENDOR "Advanced Micro Devices, Inc.")
+set(CPACK_PACKAGE_VERSION_MAJOR ${VERSION_MAJOR})
+set(CPACK_PACKAGE_VERSION_MINOR ${VERSION_MINOR})
+set(CPACK_PACKAGE_VERSION_PATCH ${VERSION_PATCH})
+set(CPACK_PACKAGE_CONTACT "AMD GFX mailing list <amd-gfx@lists.freedesktop.org>")
+set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.md")
+set(CPACK_COMPONENT_DESCRIPTION "HSAKMT development package.\n This package includes the user-mode API interfaces\nused to interact with the ROCk driver.\n This package contains the headers, pkgonfig and\n cmake files for the ROCT package.")
