=== tests/kfdtest/CMakeLists.txt ===
--- 
+++ 
@@ -24,7 +24,7 @@
 # If environment variable DRM_DIR or LIBHSAKMT_PATH is set, the script
 # will pick up the corresponding libraries from those pathes.
 
-cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
 
 project(KFDTest)
 
@@ -37,6 +37,20 @@
 set ( CPACK_PACKAGE_VERSION_MINOR "0" )
 set ( CPACK_PACKAGE_VERSION_PATCH "0" )
 set ( CPACK_PACKAGE_HOMEPAGE_URL "https://github.com/RadeonOpenCompute/ROCT-Thunk-Interface" )
+
+## Define default variable and variables for the optional build target hsakmt-dev
+set ( SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE STRING "Location of hsakmt source code." )
+set ( CMAKE_INSTALL_PREFIX "/opt/rocm"  CACHE STRING "Default installation directory." )
+set ( CPACK_PACKAGING_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}"  CACHE STRING "Default packaging prefix." )
+set ( CPACK_GENERATOR "DEB;RPM"  CACHE STRING "Default packaging generators." )
+
+# Debian package specific variables
+set ( CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/RadeonOpenCompute/ROCT-Thunk-Interface" )
+set (CPACK_DEBIAN_PACKAGE_DEPENDS "rocm-core")
+
+# RPM package specific variables
+set (CPACK_RPM_PACKAGE_REQUIRES "rocm-core")
+
 
 #set ( CMAKE_VERBOSE_MAKEFILE on )
 
@@ -57,29 +71,19 @@
     include_directories(${DRM_AMDGPU_INCLUDE_DIRS})
 endif()
 
-## Define default variable and variables for the optional build target hsakmt-dev
-set ( SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR} CACHE STRING "Location of hsakmt source code." )
-set ( CMAKE_INSTALL_PREFIX "/opt/rocm"  CACHE STRING "Default installation directory." )
-set ( CPACK_PACKAGING_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}"  CACHE STRING "Default packaging prefix." )
-set ( CPACK_GENERATOR "DEB;RPM"  CACHE STRING "Default packaging generators." )
-
-# Debian package specific variables
-set ( CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/RadeonOpenCompute/ROCT-Thunk-Interface" )
-
 if( DEFINED ENV{LIBHSAKMT_PATH} )
     set ( LIBHSAKMT_PATH $ENV{LIBHSAKMT_PATH} )
     message ( "LIBHSAKMT_PATH environment variable is set" )
 else()
     if ( ${ROCM_INSTALL_PATH} )
-       set ( ENV{PKG_CONFIG_PATH} ${ROCM_INSTALL_PATH} )
-       pkg_check_modules(HSAKMT libhsakmt)
+       set ( ENV{PKG_CONFIG_PATH} ${ROCM_INSTALL_PATH}/share/pkgconfig )
     else()
-       set ( ENV{PKG_CONFIG_PATH} /opt/rocm/libhsakmt/ )
-       pkg_check_modules(HSAKMT libhsakmt)
+       set ( ENV{PKG_CONFIG_PATH} /opt/rocm/share/pkgconfig )
     endif()
+
+    pkg_check_modules(HSAKMT libhsakmt)
+
     if( NOT HSAKMT_FOUND )
-       set ( ENV{PKG_CONFIG_PATH} /opt/rocm/libhsakmt/ )
-       pkg_check_modules(HSAKMT libhsakmt)
        set ( LIBHSAKMT_PATH $ENV{OUT_DIR} )
     endif()
 endif()
@@ -109,6 +113,7 @@
   src/GoogleTestExtension.cpp
   src/IndirectBuffer.cpp
   src/IsaGenerator.cpp
+  src/IsaGenerator_Aldebaran.cpp
   src/IsaGenerator_Gfx10.cpp
   src/IsaGenerator_Gfx72.cpp
   src/IsaGenerator_Gfx8.cpp
@@ -143,7 +148,8 @@
   src/KFDHWSTest.cpp
   src/KFDPerformanceTest.cpp
   src/KFDPMTest.cpp
-
+  src/KFDSVMRangeTest.cpp
+  src/KFDSVMEvictTest.cpp
   src/KFDRASTest.cpp
   src/RDMATest.cpp)
 
@@ -165,6 +171,12 @@
     set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g" )
 endif ()
 
+## Address Sanitize Flag
+if ( ${ADDRESS_SANITIZER} )
+    set ( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address" )
+    set ( CMAKE_EXE_LINKER_FLAGS -fsanitize=address )
+endif ()
+
 # link_directories() has to be put before add_executable()
 # The modules found by pkg_check_modules() in the default pkg config
 # path do not need to use link_directories() here.
@@ -173,7 +185,7 @@
 
 add_executable(kfdtest ${SRC_FILES})
 
-target_link_libraries(kfdtest ${HSAKMT_LIBRARIES} ${DRM_LIBRARIES} ${DRM_AMDGPU_LIBRARIES} pthread m stdc++ rt amdsp3 numa)
+target_link_libraries(kfdtest ${HSAKMT_LIBRARIES} ${DRM_LDFLAGS} ${DRM_AMDGPU_LDFLAGS} pthread m stdc++ rt amdsp3 numa)
 
 configure_file ( scripts/kfdtest.exclude kfdtest.exclude COPYONLY )
 configure_file ( scripts/run_kfdtest.sh run_kfdtest.sh COPYONLY )
@@ -184,4 +196,9 @@
 install( FILES ${CMAKE_CURRENT_BINARY_DIR}/kfdtest.exclude
 	PERMISSIONS OWNER_WRITE OWNER_READ GROUP_WRITE GROUP_READ WORLD_READ
 	DESTINATION share/kfdtest )
+# Remove dependency on rocm-core if -DROCM_DEP_ROCMCORE=ON not given to cmake
+if(NOT ROCM_DEP_ROCMCORE)
+    string(REGEX REPLACE ",? ?rocm-core" "" CPACK_RPM_PACKAGE_REQUIRES ${CPACK_RPM_PACKAGE_REQUIRES})
+    string(REGEX REPLACE ",? ?rocm-core" "" CPACK_DEBIAN_PACKAGE_DEPENDS ${CPACK_DEBIAN_PACKAGE_DEPENDS})
+endif()
 include ( CPack )
