=== debian/changelog ===
roct-thunk-interface (5.2.3+dfsg-1) unstable; urgency=medium

  * Migrate ROCm 5.2.3 to unstable.

 -- Étienne Mollier <emollier@debian.org>  Mon, 17 Oct 2022 21:58:47 +0200

roct-thunk-interface (5.2.3+dfsg-1~0exp0) experimental; urgency=medium

  * New upstream version
  * Apply multi-arch hints.
    + libhsakmt-dev: Add Multi-Arch: same.

 -- Étienne Mollier <emollier@debian.org>  Mon, 05 Sep 2022 21:58:15 +0200
