=== debian/control ===
--- 
+++ 
@@ -35,6 +35,7 @@
 Section: libdevel
 Architecture: any
 Depends: libhsakmt1 (= ${binary:Version}), ${misc:Depends},
+Multi-Arch: same
 Description: Thunk library for AMD KFD (dev)
  This package includes the user-mode API interfaces used to interact with the
  ROCk driver. Currently supported agents include only the AMD/ATI Fiji family
