=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure
	sed -e 's/@DEB_HOST_MULTIARCH@/$(DEB_HOST_MULTIARCH)/g' \
		debian/libhsakmt-dev.install.in > \
		debian/libhsakmt-dev.install
